﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.IO;

namespace GoogleApiTest
{
    public partial class Form1 : Form
    {
        //dllのImport
        //検索API
        [DllImport("GoogleSearch.dll")]
        public extern static void Search(int mode, string in_str);
        //SpeechAPI
        [DllImport("SpeechDialog.dll")]
        public extern static bool SpeechDlg(IntPtr Handle, [MarshalAs(UnmanagedType.LPArray)] byte[] res);
        //予測変換API
        [DllImport("GoogleSuggest.dll")]
        public extern static void Suggest(string in_str, [MarshalAs(UnmanagedType.LPArray)] byte[] res);
        //音声合成API
        [DllImport("GoogleTTS.dll")]
        public extern static void TTS(string in_str);

        public int SearchMode = 0;

        public Form1()
        {
            InitializeComponent();
        }

        //生成時
        private void Form1_Load(object sender, EventArgs e)
        {
            listBox1.Items.Clear();
        }
        
        //検索
        private void button1_Click(object sender, EventArgs e)
        {
            if (textBox1.Text != "")
            {
                Encoding sjisEnc = Encoding.GetEncoding("Shift_JIS");
                byte[] bytes = sjisEnc.GetBytes(textBox1.Text);
                //MemoryStreamオブジェクトの作成
                System.IO.MemoryStream ms = new System.IO.MemoryStream();
                //バイト型配列をMemoryStreamに追加する
                ms.Write(bytes, 0, bytes.Length);
                //さらに追加する
                byte[] bs = new byte[] {0};
                ms.Write(bs, 0, bs.Length);
                //MemoryStreamの大きさを変更する
                ms.SetLength(bytes.Length + bs.Length);
                //MemoryStreamの内容をバイト型配列に変換する
                bytes = ms.ToArray();
                //閉じる
                ms.Close();

                //Console.WriteLine(BitConverter.ToString(bytes));
                Search(SearchMode, textBox1.Text);
            }
        }
        //ラジオボタンの変更
        private void radioButton_CheckedChanged(object sender, EventArgs e)
        {
            RadioButton _RadioButton = (RadioButton)sender;
            if (_RadioButton.Checked == true)
            {
                SearchMode = int.Parse((string)((_RadioButton.Tag)));
            }
        }
        //音声入力
        private void button2_Click(object sender, EventArgs e)
        {
            byte[] res_byte = new byte[4096];
            bool res;
            res = SpeechDlg(this.Handle, res_byte);
            //変換(SJISだと"shift_jis")
            string str = System.Text.Encoding.GetEncoding("shift_jis").GetString(res_byte);
            if (res)
            {
                textBox1.Text = str;
                str = "\r\n" + str;
                textBox2.AppendText(str);
            }
        }
        //予測変換
        private void textBox3_TextChanged(object sender, EventArgs e)
        {
            byte[] res_byte = new byte[4096];
            if (textBox3.Text == "")
            {
                listBox1.Items.Clear();
            }
            else
            {
                listBox1.Items.Clear();
                //変換(SJISだと"shift_jis")
                Suggest(textBox3.Text, res_byte);
                string str = System.Text.Encoding.GetEncoding("shift_jis").GetString(res_byte);
                //改行区切りで分割して配列に格納する
                string[] strArray = str.Split('\n');
                //listBoxに追加
                for (int i = 0; i < strArray.Length; i++)
                {
                    listBox1.Items.Add(strArray[i]);
                }
            }
        }
        //ダブルクリック
        private void listBox1_DoubleClick(object sender, EventArgs e)
        {
            if (listBox1.Items.Count == 0) return;
            if (listBox1.SelectedIndex < 0) return;
            textBox1.Text = listBox1.Text;
        }
        //音声合成
        private void button3_Click(object sender, EventArgs e)
        {
            if (textBox1.Text != "")
            {
                TTS(textBox1.Text);
            }
        }

    }
}
